/**
 * @file $RCSfile: uart_lib.h,v $
 *
 * Copyright (c) 2004 Atmel.
 *
 * 쌠ʒmɂĂlicense.txţقǂłB
 *
 * @brief ̧قUARTײ ͯ ̧ق܂݂܂B
 *
 * @version $Revision: 1.14.4.5 $ $Name: demo-bldc-sensor-at90pwm3-4_7_0 $
 *
 * @todo
 * @bug
 */

#ifndef _UART_LIB_H_
#define _UART_LIB_H_

/*_____ ݸٰ ̧ ________________________________________________________*/
#include "uart_drv.h"

/*_____ ` ________________________________________________________________*/
#ifndef UART_CONFIG
#define UART_CONFIG		MSK_UART_8BIT
#endif

#ifndef BAUDRATE
#error You must define BAUDRATE in config.h
#define BAUDRATE		999
#endif

#define AUTOBAUD		0

#if BAUDRATE == AUTOBAUD
#define Uart_set_baudrate(bdr)  autobaud()
#include "modules/autobaud/autobaud.h"
#else
#include "lib_mcu/uart/uart_bdr.h"
#endif

/*_____ 錾 ________________________________________________________________*/

/*_____ ϸ _________________________________________________________________*/

/*_____ ^錾 ____________________________________________________________*/

/**
 * @brief ̊֐BAUDRATE̒萔`ɏ]UART`Ԑݒݸނ`Ԑݒ肵
 * UART܂B
 *
 * @pre ̊֐ĂԑOɂ̐錾config.hŒ`Ȃ΂Ȃ܂
 * B:\n
 * - FOSC : kHzł̸ؽَg(K{)A(Wؽقp\)
 * - BAUDRATE : UART`ԐݒŎgpޯ/błްڰ(K{)
 * - UART_CONFIG : (8ޯāAèȂA1~ޯ)
 *
 */
bit uart_init (void);

/**
 * @brief ̊֐UARTɕ̑M܂B
 *
 * @param uc_wr_byte UARTɏo͂镶
 *
 * @return 
 *
 * @par :
 *  ^p_uart_ptcharr_uart_ptcharprintfł̗vɍ悤ɒ`邱Ƃł܂B
 *
 */
r_uart_ptchar uart_putchar (p_uart_ptchar uc_wr_byte);

/**
 * @brief ̊֐UART當𓾂邱Ƃ܂B
 *
 * @return ǂ񂾕
 *
 */
r_uart_gtchar uart_getchar (void);

/**
 * @brief ̊֐͕Mꂽ̒ʒm܂B
 *
 * @return Mꂽꍇɐ^(True)
 *
 */
bit uart_test_hit (void);

#endif /* _UART_LIB_H_ */
